/*##############################################################################

    HPCC SYSTEMS software Copyright (C) 2012 HPCC Systems.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
############################################################################## */

rec :=
RECORD
            integer i;
        string1 id;
END;

 recout :=
RECORD
        string1 idL;
        string1 idR;
END;

sv1 := 1  : stored('sv1');

ds1 := nofold(DATASET([{1,'A'}, {1,'B'}, {1,'C'}], rec));
ds2 := nofold(DATASET([{1,'D'}], rec));
ds3 := nofold(DATASET([{1,'E'}, {1,'F'}, {1,'G'}], rec));
ds4 := nofold(DATASET([{1,'A'}], rec));
ds5 := nofold(DATASET([{1,'B'}], rec));
ds6 := nofold(DATASET([{1,'A'}, {1,'B'}], rec));
ds7 := nofold(DATASET([{1,'C'}, {1,'D'}, {1,'E'}], rec));
ds8 := nofold(DATASET([{1,'A'}, {1,'B'}, {1,'C'}], rec));
ds9 := nofold(DATASET([{2,'A'}], rec));
ds10 := nofold(DATASET([{0,'A'}], rec));

recout trans(rec L, rec R) :=
TRANSFORM

            SELF.idl := L.id;
            SELF.idr := R.id;
END;

recout transkip(rec L, rec R) :=
TRANSFORM

            SELF.idl := if(L.id='A',skip,L.id);
            SELF.idr := if(R.id='A',skip,R.id);
END;

j1 := JOIN(ds1, ds2, LEFT.i = RIGHT.i, trans(LEFT, RIGHT));
j2 := JOIN(ds1, ds2, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1), LEFT OUTER);
j3 := JOIN(ds1, ds2, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), ATMOST(1), LEFT OUTER);
j4 := JOIN(ds2, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT));
//j5 := JOIN(ds2, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1), RIGHT OUTER);
j6 := JOIN(ds1, ds7, (LEFT.i = RIGHT.i), transkip(LEFT, RIGHT));
j7 := JOIN(ds1, ds2, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), LEFT OUTER);
j8 := JOIN(ds2, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), RIGHT OUTER);
j9 := JOIN(ds4, ds3, (LEFT.i = RIGHT.i)and(RIGHT.id>'E'), trans(LEFT, RIGHT), KEEP(2));
j10 := JOIN(ds1, ds5, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT));
j11 := JOIN(ds1, ds5, (LEFT.i = RIGHT.i)and(LEFT.id>=RIGHT.id), trans(LEFT, RIGHT));
j12 := JOIN(ds1, ds3, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT), KEEP(2),LEFT OUTER);
j13 := JOIN(ds6, ds7, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT), KEEP(5));
//j14 := JOIN(ds6, ds7, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT), KEEP(1),RIGHT OUTER);
j15 := JOIN(ds1, ds7, (LEFT.i = RIGHT.i), transkip(LEFT, RIGHT));
j16 := JOIN(ds1, ds5, (LEFT.i = RIGHT.i)and(LEFT.id>=RIGHT.id), trans(LEFT, RIGHT));
j17 := JOIN(ds1, ds3, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1),left OUTER);
//j18 := JOIN(ds1, ds3, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1),FULL ONLY);
//j19 := JOIN(ds1, ds3, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1),RIGHT OUTER);
//j20 := JOIN(ds1, ds3, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1),RIGHT ONLY);
j21 := JOIN(ds7, ds1, (LEFT.i = RIGHT.i)and(LEFT.id<=RIGHT.id), trans(LEFT, RIGHT));
j22 := JOIN(ds1, ds1, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT), KEEP(1));
j23 := JOIN(ds1, ds8, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT), KEEP(1));
j24 := JOIN(ds1, ds8, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT), LOOKUP);
j25 := JOIN(ds1, ds8, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT), ATMOST(1));
j26 := JOIN(ds1, ds1, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT));
j27 := JOIN(ds1, ds8, (LEFT.i = RIGHT.i), trans(LEFT, RIGHT));
j28 := JOIN(ds7, ds1, (LEFT.i = RIGHT.i)and(LEFT.id<=RIGHT.id), trans(LEFT, RIGHT), LEFT OUTER, LOOKUP);
j29 := JOIN(ds1, ds9, LEFT.i = RIGHT.i, trans(LEFT, RIGHT));
j30 := JOIN(ds1, ds9, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1), LEFT OUTER);
j31 := JOIN(ds1, ds9, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), LOOKUP, LEFT OUTER);
j32 := JOIN(ds1, ds9, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), ATMOST(1), LEFT OUTER);
j33 := JOIN(ds1, ds9, LEFT.i = RIGHT.i, trans(LEFT, RIGHT));
//j34 := JOIN(ds1, ds9, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1), RIGHT OUTER);
j35 := JOIN(ds1, ds9, (LEFT.i = RIGHT.i)and(RIGHT.id>'E'), trans(LEFT, RIGHT), KEEP(2));
j36 := JOIN(ds9, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT));
j37 := JOIN(ds9, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1), LEFT OUTER);
j38 := JOIN(ds9, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), LOOKUP, LEFT OUTER);
j39 := JOIN(ds9, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), ATMOST(1), LEFT OUTER);
j40 := JOIN(ds9, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT));
//j41 := JOIN(ds9, ds1, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), KEEP(1), RIGHT OUTER);
j42 := JOIN(ds9, ds1, (LEFT.i = RIGHT.i)and(RIGHT.id>'E'), trans(LEFT, RIGHT), KEEP(2));
j43 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT));
j44 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), KEEP(1), LEFT OUTER);
j45 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), LOOKUP);
j46 := JOIN(ds1, ds1, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), LOOKUP);
j47 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, trans(LEFT, RIGHT), LOOKUP, LEFT OUTER);
j48 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), LOOKUP, LEFT OUTER);
j49 := JOIN(ds1, ds8, (LEFT.i = RIGHT.i)and(RIGHT.id>'E'), transkip(LEFT, RIGHT), LOOKUP);
j50 := JOIN(ds1, ds8, (LEFT.i = RIGHT.i)and(RIGHT.id>'E'), transkip(LEFT, RIGHT), LOOKUP, LEFT OUTER);
j51 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), LOOKUP, LEFT OUTER);
j52 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT));
j53 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), KEEP(1), LEFT OUTER);
j54 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), LOOKUP, LEFT OUTER);
j55 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), ATMOST(1), LEFT OUTER);
j56 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT));
j57 := JOIN(ds1, ds8, LEFT.i = RIGHT.i, transkip(LEFT, RIGHT), many LOOKUP, keep(sv1), local);
j58 := JOIN(ds1, ds8, (LEFT.i = RIGHT.i)and(RIGHT.id>'E'), transkip(LEFT, RIGHT), KEEP(2));

sequential(
    output(j1),
    output(j2),
    output(j3),
    output(j4),
//  output(j5),
    output(j6),
    output(j7),
    output(j8),
    output(j9),
    output(j10),
    output(j11),
    output(j12),
    output(j13),
//  output(j14),
    output(j15),
    output(j16),
    output(j17),
//  output(j18),
//  output(j19),
//  output(j20),
    output(j21),
    output(j22),
    output(j23),
    output(j24),
    output(j25),
    output(j26),
    output(j27),
    output(j29),
    output(j30),
    output(j31),
    output(j32),
    output(j33),
//  output(j34),
    output(j35),
    output(j36),
    output(j37),
    output(j38),
    output(j39),
    output(j40),
//  output(j41),
    output(j42),
    output(j43),
    output(j44),
    output(j45),
    output(j46),
    output(j47),
    output(j48),
    output(j49),
    output(j50),
    output(j51),
    output(j52),
    output(j53),
    output(j54),
    output(j55),
    output(j56),
    output(j57),
    output(j58)
);

